package de.hdm_stuttgart.battlearena.Persistance.Classes;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.ArrayList;
import java.util.LinkedHashMap;

public class RuntimeInfo {

    private static final Logger log = LogManager.getLogger(RuntimeInfo.class);
    private static final RuntimeInfo runtimeInfoSingleton = new RuntimeInfo();
    private final Persistence persistenceInst = Persistence.getInstance();
    private LinkedHashMap<String, String> mapNames;
    public MapData mapCreated;  //to store parsed Data from MapCreator for Upload to SQL
    public String communityMapSelected;
    protected ArrayList<String> coreMapsListLocal;
    protected ArrayList<String> communityMapsListLocal;
    protected ArrayList<String> communityMapsListRemote;
    protected String mapDataGame;




    private RuntimeInfo(){};
    public static RuntimeInfo getInstance(){
        return runtimeInfoSingleton;
    }

    public String getMapDataGame() {
        return mapDataGame;
    }

    private void setGameMap(String mapSelected, boolean choseCoremaps){
        mapSelected = mapSelected.substring(mapSelected.indexOf("(") + 1, mapSelected.length() - 1);

        if(choseCoremaps) {
            for (int mapListIndex = 0; mapListIndex < persistenceInst.coreMaps.size(); mapListIndex++) {
                if (persistenceInst.coreMaps.get(mapListIndex).getMapID().equals("mapSelected")) {
                    mapDataGame = persistenceInst.coreMaps.get(mapListIndex).getMapID();
                }
            }
        }
        else  {
            for (int mapListIndex = 0; mapListIndex < persistenceInst.communityMaps.size(); mapListIndex++) {
                if (persistenceInst.communityMaps.get(mapListIndex).getMapID().equals("mapSelected")) {
                    mapDataGame = persistenceInst.coreMaps.get(mapListIndex).getMapID();
                }
            }
        }
    }

    public void getCommunityMap(){
        persistenceInst.getCommunityMap(communityMapSelected);
    }

    public void uploadMapCreated(){
        persistenceInst.uploadCommunityMap(mapCreated);
    }
    //add Hash-Creator for creating map_ID and parse if map_data is according to specs

    private void updateStats(String outcome, String kills, String deaths, int gameTime){
        //update PlayerStatistics
        //update SQL
    }

    public void createCoreMapsList(){
        for(int i = 0; i < persistenceInst.coreMaps.size(); i++){
            coreMapsListLocal.add(persistenceInst.coreMaps.get(i).getMapName() + " (" + persistenceInst.coreMaps.get(i).getMapID() + ")");
        }
    }

    public void createCommunityMapsListLocal(){
        try {
            for (int i = 0; i < persistenceInst.communityMaps.size(); i++) {
                communityMapsListLocal.add(persistenceInst.communityMaps.get(i).getMapName() + " (" + persistenceInst.communityMaps.get(i).getMapID() + ")");
            }
        }
        catch (Exception e){
            log.info(e);
        }
    }
    //if no Data in JSON throw Exception and inform user

    public void fetchCommunityMapListRemote(){
        try {
            communityMapsListRemote = persistenceInst.db.getCommunityMapsList();
            log.info("MapList successfully retrieved from server!");
            log.info(communityMapsListRemote.get(0));                 //for testing purposes
        }
        catch(Exception e){
            log.error(e);
        }
    }

    public void getStatsByID(String playerID){
        //fetches from SQL stats by player with provided ID - players can display stats of other players in "Statistics" Scene
    }

}
